import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React from 'react';
import PropTypes from 'prop-types';
import cx from 'classnames';
var BASE_CLASS = 'sui-AtomInput-addon';
var TYPES = {
  LEFT: 'left',
  RIGHT: 'right'
};

var AddonHoC = function AddonHoC(WrappedInput) {
  return (
    /*#__PURE__*/
    function (_React$Component) {
      _inheritsLoose(Addon, _React$Component);

      function Addon() {
        return _React$Component.apply(this, arguments) || this;
      }

      var _proto = Addon.prototype;

      _proto.getClassName = function getClassName(_ref) {
        var type = _ref.type;
        return cx(BASE_CLASS, BASE_CLASS + "--" + type);
      };

      _proto.render = function render() {
        var _this$props = this.props,
            leftAddon = _this$props.leftAddon,
            rightAddon = _this$props.rightAddon,
            props = _objectWithoutProperties(_this$props, ["leftAddon", "rightAddon"]);

        return leftAddon || rightAddon ? React.createElement("div", {
          className: 'sui-AtomInput-addonWrapper'
        }, leftAddon && React.createElement("span", {
          className: this.getClassName({
            type: TYPES.LEFT
          })
        }, leftAddon), React.createElement(WrappedInput, props), rightAddon && React.createElement("span", {
          className: this.getClassName({
            type: TYPES.RIGHT
          })
        }, rightAddon)) : React.createElement(WrappedInput, props);
      };

      return Addon;
    }(React.Component)
  );
};

export default AddonHoC;