import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React, { Component } from 'react';
import PropTypes from 'prop-types';
import Input from '../Input';

var MaskInput =
/*#__PURE__*/
function (_Component) {
  _inheritsLoose(MaskInput, _Component);

  function MaskInput() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, [this].concat(args)) || this;

    _this.onChange = function (ev, _ref) {
      var value = _ref.value;
      var onChange = _this.props.onChange;
      onChange && onChange(ev, {
        value: value
      });
    };

    _this.onFocus = function () {
      var mask = _this.props.mask;

      if (!_this.mask) {
        import('imask').then(function (imaskPackage) {
          var IMask = imaskPackage["default"];
          _this.mask = new IMask(_this.field, mask);
        });
      }
    };

    return _this;
  }

  var _proto = MaskInput.prototype;

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.mask && this.mask.destroy();
  };

  _proto.render = function render() {
    var _this2 = this;

    var name = this.props.name;
    return React.createElement(Input, Object.assign({
      id: name,
      reference: function reference(input) {
        _this2.field = input;
      },
      onChange: this.onChange,
      onFocus: this.onFocus
    }, this.props));
  };

  return MaskInput;
}(Component);

MaskInput.displayName = 'MaskInput';
export default MaskInput;