import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _inheritsLoose from "@babel/runtime/helpers/esm/inheritsLoose";
import React from 'react';
import PropTypes from 'prop-types';
import Input from '../Input';
var TEXT = 'text';
var PASSWORD = 'password';
var HIDE_LABEL = 'hide';
var SHOW_LABEL = 'show';

var Password =
/*#__PURE__*/
function (_React$Component) {
  _inheritsLoose(Password, _React$Component);

  function Password() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    _this.state = {
      type: PASSWORD,
      value: ''
    };

    _this.toggle = function () {
      var type = _this.state.type;
      var inputType = type === PASSWORD ? TEXT : PASSWORD;

      _this.setState({
        type: inputType
      });
    };

    _this.onChange = function (ev, _ref) {
      var value = _ref.value;

      _this.setState({
        value: value
      }, function () {
        var onChange = _this.props.onChange;
        onChange && onChange(ev, {
          value: value
        });
      });
    };

    return _this;
  }

  var _proto = Password.prototype;

  _proto.render = function render() {
    var _this$props = this.props,
        pwShowLabel = _this$props.pwShowLabel,
        pwHideLabel = _this$props.pwHideLabel,
        props = _objectWithoutProperties(_this$props, ["pwShowLabel", "pwHideLabel"]);

    var _this$state = this.state,
        type = _this$state.type,
        value = _this$state.value;
    return React.createElement("div", {
      className: "sui-AtomInput-password"
    }, React.createElement(Input, Object.assign({}, props, {
      onChange: this.onChange,
      value: value,
      type: type
    })), React.createElement("div", {
      onClick: this.toggle,
      className: "sui-AtomInput-password--toggleButton"
    }, type === PASSWORD ? pwShowLabel : pwHideLabel));
  };

  return Password;
}(React.Component);

Password.defaultProps = {
  pwShowLabel: SHOW_LABEL,
  pwHideLabel: HIDE_LABEL
};
export default Password;