import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import React from 'react';
import PropTypes from 'prop-types';
import Input, { inputSizes } from './Input';
import Password from './Password';
import Mask from './Mask';

var AtomInput = function AtomInput(_ref) {
  var type = _ref.type,
      props = _objectWithoutProperties(_ref, ["type"]);

  switch (type) {
    case 'sui-password':
      return React.createElement(Password, props);

    case 'mask':
      return React.createElement(Mask, props);

    default:
      return React.createElement(Input, Object.assign({}, props, {
        type: type
      }));
  }
};

AtomInput.displayName = 'AtomInput';
export default AtomInput;
export { inputSizes };